# mine-api

`mine-api` is a simple wrapper around the [Minecraft API](http://wiki.vg/Mojang_API). The package is really lightweight and does use Promises as retuntype.

## Installation

    npm install --save mine-api

## Usage

### MinecraftAPI.uuidForName(username)

Parameters:

 * **username**: The username to resolve the UUID for
 
Example:
 ```js
 const MinecraftAPI = require('mine-api');
 
 function foo() {
     MinecraftAPI.uuidForName('jeb_')
         .then(uuid => console.log(uuid))
         .catch(err => console.log(err))
 }
 ```

Example (async/await):
```js
const MinecraftAPI = require('mine-api');

async function foo() {
    try{
        const uuid = await MinecraftAPI.uuidForName('jeb_'); 
        console.log(uuid);
    } catch(err){
        console.error(err);
    }
}
```
